FUNCTION GetXMLFromCursor( tcCursorNames AS STRING, tlForceXmlAdapter AS Boolean ) AS STRING
  LOCAL lcXML AS STRING        ,;
    lcParserType AS STRING    ,;
    lnTotalAlias AS INTEGER   ,;
    lcAlias AS STRING         ,;
    lnTotalParts AS INTEGER   ,;
    lnRecnoFrom AS INTEGER    ,;
    lnRecnoTo AS INTEGER      ,;
    loXA AS XMLADAPTER
  lnTotalAlias = GETWORDCOUNT( tcCursorNames, "," )
  IF lnTotalAlias = 1
    IF RECCOUNT( tcCursorNames ) > 1000
      lcParserType = "XML3"
    ENDIF
  ELSE
    FOR niCount = 1 TO lnTotalAlias
      lcAlias = GETWORDNUM( tcCursorNames, niCount, "," )
      * If cursor have more than 10.000 records, change the Parser type
      IF USED( lcAlias ) AND RECCOUNT( lcAlias ) > 1000
        IF RECCOUNT( lcAlias ) > 80000
          lcParserType = ""
        ELSE
          IF EMPTY( lcParserType )
            lcParserType = "MULTI"
          ENDIF
        ENDIF
        EXIT
      ENDIF
    NEXT
  ENDIF
  IF tlForceXmlAdapter
    lcParserType = ""
  ENDIF
  lcXML = ""
  DO CASE
    CASE lcParserType = "MULTI"
      lnTotalAlias = GETWORDCOUNT( tcCursorNames, "," )
      lcXML = ""
      FOR niCount = 1 TO lnTotalAlias
        * Get the alias name to process
        lcAlias = GETWORDNUM( tcCursorNames, niCount, "," )
        IF NOT EMPTY( lcAlias ) AND USED( lcAlias )
          LOCAL lnTotalFields
          lnTotalFields = AFIELDS( laFields, lcAlias )
          * If the cursor has more than 20 fields and 10.000 records,
          * set the limit to 5.000 records.
          IF ( lnTotalFields >= 20 ) AND ( RECCOUNT( lcAlias ) >= 20000 )
            lnMultiple = 10000
          ELSE
            lnMultiple = 20000
          ENDIF
          SELECT ( lcAlias )
          IF RECCOUNT( lcAlias ) <= lnMultiple
            lcXML = lcXML + THIS.AddMultiTable( lcAlias )
          ELSE
            * If the cursor has too much information,
            * divide the cursor in parts
            * to minize the XmlToCursor() work.
            lnTotalParts = INT( CEILING( RECCOUNT( lcAlias ) / lnMultiple ) )
            FOR njCount = 1 TO lnTotalParts
              SET FILTER TO
              IF njCount = 1
                lnRecnoFrom = 1
                lnRecnoTo   = lnMultiple
              ELSE
                lnRecnoFrom = lnMultiple * ( njCount - 1 )
                lnRecnoTo   = lnMultiple * njCount
              ENDIF
              LOCATE
              lcXML = lcXML ;
                + THIS.AddMultiTable( lcAlias, njCount, lnRecnoFrom, lnRecnoTo )
            NEXT
          ENDIF
        ENDIF
      NEXT
    CASE lcParserType = "XML3"
      CURSORTOXML( tcCursorNames, "lcXML", 3, 8, 0, "1" )
      lcXML = "<XML3Table><XML3TableName>" ;
        + UPPER( tcCursorNames ) + "" ;
        + lcXML + "</XML3Table>"
    OTHERWISE
      loXA = CREATEOBJECT( "XmlAdapter" )
      lnTotal = OCCURS( ",", tcCursorNames ) + 1
      FOR niCount = 1 TO lnTotal
        lcAlias = GETWORDNUM( tcCursorNames, niCount, "," )
        IF NOT USED( lcAlias )
          ERROR "cursor " + lcAlias + " is not opened"
        ELSE
          loXA.ADDTABLESCHEMA( lcAlias )
        ENDIF
      NEXT
      loXA.TOXML( "lcXml" )
  ENDCASE
  RETURN ( lcXML )
ENDFUNC

HIDDEN FUNCTION AddMultiTable( ;
    tcAlias AS STRING, ;
    tnPartNo AS INTEGER, ;
    tnRecnoFrom AS INTEGER, ;
    tnRecnoTo AS INTEGER ) ;
    AS STRING
  LOCAL lcXML AS STRING, lcXmlPart AS STRING, lcAlias AS STRING
  lcXML     = ""
  lcXmlPart = ""
  lcAlias   = tcAlias
  IF NOT EMPTY( lcAlias ) AND USED( lcAlias )
    SELECT ( lcAlias )
    LOCATE
    IF NOT EMPTY( tnRecnoTo )
      SET FILTER TO BETWEEN( RECNO( lcAlias ), tnRecnoFrom, tnRecnoTo ) IN ( lcAlias )
    ENDIF
    CURSORTOXML( lcAlias, "lcXmlPart", 3, 8, 0, "1" )
    IF NOT EMPTY( tnRecnoTo )
      SET FILTER TO
    ENDIF
    IF NOT EMPTY( tnPartNo )
      lcAlias = "%" + tcAlias + "__" + ALLTRIM( STR( tnPartNo ) )
    ENDIF
    lcXML = "<MultiTable>" + "<MultiTableName>" + UPPER( ALLTRIM( lcAlias ) ) ;
      +  "</MultiTableName>" + lcXmlPart + "</MultiTable>" + CHR( 13 )
  ENDIF
  RETURN ( lcXML )
ENDFUNC

FUNCTION GetCursorFromXML( tcXML AS STRING, tcCursorNames AS STRING  ) AS STRING
  LOCAL oXmlAdapter AS XMLADAPTER ,;
    lcParserType AS STRING       ,;
    lnTotalParts AS INTEGER      ,;
    lnActualClone AS INTEGER     ,;
    lcFinalAlias AS STRING       ,;
    lcCursorNames AS STRING      ,;
    niCount AS INTEGER           ,;
    lcAlias AS STRING
  IF EMPTY( tcCursorNames )
    tcCursorNames = ""
  ENDIF
  DO CASE
    CASE ( "</MultiTableName>" $ tcXML )
      lcParserType = "MULTI"
    CASE ( "</XML3TableName>" $ tcXML )
      lcParserType = "XML3"
    OTHERWISE
      lcParserType = ""
  ENDCASE
  DO CASE
    CASE lcParserType == "MULTI"
      lnTotalAlias = OCCURS( "</MultiTableName>", tcXML )
      IF "<MultiTableName>%" $ tcXML
        tcCursorNames = ""
      ENDIF
      lnTally = 0
      lnTotalParts = 0
      FOR niCount = 1 TO lnTotalAlias
        * Get the XML for the current cursor
        lcXmlPart = STREXTRACT( tcXML, "<MultiTable>", "</MultiTable>", niCount )
        IF NOT EMPTY( tcCursorNames )
          lcAlias = GETWORDNUM( tcCursorNames, niCount, "," )
        ELSE
          lcAlias = STREXTRACT( lcXmlPart, "<MultiTableName>", "</MultiTableName>", 1 )
          IF LEFT( lcAlias, 1 ) == "%"
            lnActualPart = INT( VAL( SUBSTR( lcAlias, AT( "__", lcAlias ) + 2 ) ) )
            * if this is a first part from a new cursor, generate the last cursor
            IF lnActualPart < lnTotalParts
              THIS.GetCursorFromPartXML( lcFinalAlias, lnTotalParts )
            ENDIF
            lcAlias      = SUBSTR( lcAlias, 2 )
            lnTotalParts = lnActualPart
            lcFinalAlias = LEFT( lcAlias, LEN( lcAlias ) ;
              - ( LEN( ALLTRIM( STR( lnTotalParts ) ) ) + 2 ) )
            lcXmlPart    = STRTRAN( lcXmlPart, "<MultiTableName>" ;
              + "%" + UPPER( ALLTRIM( lcAlias ) ) ;
              + "</MultiTableName>", "" )
          ELSE
            IF lnTotalParts > 0
              THIS.GetCursorFromPartXML( lcFinalAlias, lnTotalParts )
              lnTotalParts = 0
            ENDIF
          ENDIF
        ENDIF
        * Clear some strings
        lcXmlPart = STRTRAN( lcXmlPart, "<MultiTableName>" ;
          + UPPER( ALLTRIM( lcAlias ) )+ "</MultiTableName>", "" )
        lcXmlPart = STRTRAN( lcXmlPart, "<MultiTable>", "" )
        lcXmlPart = STRTRAN( lcXmlPart, "</MultiTable>", "" )
        IF USED( lcAlias )
          USE IN ( lcAlias )
        ENDIF
        XMLTOCURSOR( lcXmlPart, lcAlias, 2048 )
      NEXT
      IF lnTotalParts > 0
        THIS.GetCursorFromPartXML( lcFinalAlias, lnTotalParts )
      ENDIF
    CASE lcParserType == "XML3"
      IF EMPTY( tcCursorNames )
        tcCursorNames = STREXTRACT( tcXML, "<XML3TableName>", "</XML3TableName>", 1 )
      ENDIF
      lcXML = STREXTRACT( tcXML, "<XML3Table>", "</XML3Table>", 1 )
      lcXML = STRTRAN( lcXML, "<XML3TableName>" ;
        + UPPER( ALLTRIM( tcCursorNames ) )+ "</XML3TableName>", "" )
      lcXML = STRTRAN( lcXML, "<XML3Table>", "" )
      lcXML = STRTRAN( lcXML, "</XML3Table>", "" )
      IF USED( tcCursorNames )
        USE IN ( tcCursorNames )
      ENDIF
      XMLTOCURSOR( lcXML, tcCursorNames, 2048 )
    OTHERWISE
      loXA = CREATEOBJECT( "XmlAdapter" )
      WITH loXA
        .LOADXML( tcXML, LEFT( tcXML, 1 ) <> "<" AND FILE( tcXML ) )
        WITH .TABLES
          FOR niCount = 1 TO loXA.TABLES.COUNT
            lcCursor = ALLTRIM( .ITEM[ niCount ].ALIAS )
            lcCurPar = IIF( .COUNT = 1, GETWORDNUM( tcCursorNames, niCount, "," ), "" )
            IF USED( lcCurPar )
              USE IN ( lcCurPar )
            ENDIF
            .ITEM[ niCount ].TOCURSOR( ,IIF( EMPTY( lcCurPar ), lcCursor, lcCurPar ) )
          NEXT
        ENDWITH
      ENDWITH
  ENDCASE
ENDFUNC

HIDDEN FUNCTION GetCursorFromPartXML( tcAlias AS STRING, tnTotalParts AS INTEGER )
  LOCAL lcSqlCmd AS STRING ,;
    niCount AS INTEGER  ,;
    njCount AS INTEGER
  lcSqlCmd = ""
  FOR niCount = 1 TO tnTotalParts
    lcSqlCmd = lcSqlCmd + IIF( EMPTY( lcSqlCmd ), "", " union all " ) ;
      + "select * from " + tcAlias + "__" + ALLTRIM( STR( niCount ) )
  NEXT
  lcSqlCmd = lcSqlCmd + " into cursor " + tcAlias + " readwrite"
  IF USED( tcAlias )
    USE IN ( tcAlias )
  ENDIF
  &lcSqlCmd
  FOR niCount = 1 TO tnTotalParts
    lcAlias = tcAlias + "__" + ALLTRIM( STR( niCount ) )
    IF USED( lcAlias )
      USE IN ( lcAlias )
    ENDIF
  NEXT
ENDFUNC
