*====================================
*Refresh:
*====================================

local lcMessage
= seek(val(Thisform.cCurrentNodeID), 'Suppliers', 'SupplierID')
lcMessage = 'Supplier: ' + trim(Suppliers.CompanyName)
Thisform.UpdateMessagePanel(lcMessage)

*====================================
*FillTreeViewCursor:
*====================================

* Parent records are suppliers.

if used('Suppliers')
	select Suppliers
else
	select 0
	use Suppliers
endif used('Suppliers')
scan
	insert into (This.cCursorAlias) (ID, TYPE, TEXT, IMAGE, SORTED, PAGE) ;
		values (transform(Suppliers.SupplierID), 'Supplier', ;
			Suppliers.CompanyName, 'Supplier', .T., 8)
endscan

* Child records are products from each supplier.

select Products
scan
	insert into (This.cCursorAlias) (ID, TYPE, PARENTID, PARENTTYPE, TEXT, ;
			IMAGE, PAGE) ;
		values (transform(Products.ProductID), 'Product', ;
			transform(Products.SupplierID), 'Supplier', ;
			Products.ProductName, 'Product', 2)
endscan

*====================================
*LoadImages:
*====================================

* Load the images for the ImageList control. 

with This.oImageList
	.ListImages.Add(1, 'Product',  loadpicture('Images\Product.ico'))
	.ListImages.Add(2, 'Supplier', loadpicture('Images\Supplier.ico'))
endwith
