*==============================================================================
* Program:				MACROVSNAMEEXP.PRG
* Purpose:				Speed test macro vs. name expression
* From:				    We Used to Do it That Way, But
* Copyright:			(c) 2008 Tamar E. Granor, Ph.D.
* Last revision:		09/13/08
*==============================================================================

LOCAL nPass, cTable, cAlias, cOrder

#DEFINE PASSES 100

OPEN DATABASE "D:\FOX\VFP9\SAMPLES\Northwind\Northwind"

cTable = "OrderDetails"
cAlias = "OrdDet"
cOrder = "PrimaryKey"

* Switch to a new work area
SELECT 0 

* Do it once to have the table open
USE OrderDetails

SELECT 0

* First, use macros
nStart = SECONDS()
FOR nPass = 1 TO Passes
	USE &cTable ORDER &cOrder ALIAS &cAlias AGAIN 
	USE IN &cAlias
ENDFOR 
nEnd = SECONDS()

? "Using macros, " + TRANSFORM(Passes) + " passes takes " + TRANSFORM( m.nEnd-m.nStart) + " seconds."


* Switch to a new work area
SELECT 0 

* Now, use name expressions
nStart = SECONDS()
FOR nPass = 1 TO Passes
	USE (cTable) ORDER (cOrder) ALIAS (cAlias) AGAIN 
	USE IN (cAlias)
ENDFOR 
nEnd = SECONDS()

?"Using name expressions, " + TRANSFORM(Passes) + " passes takes " + TRANSFORM(m.nEnd-m.nStart) + " seconds."


